// This macro developed by Valeh Rustamov, AG Prof. Rüdiger Rudolf & Prof. Mathias Hafner//
//www.uni-heidelberg.de/izn/researchgroups/rudolf/

///Wellcome window

	macro "SegToolbyRustamov" {
	requires("1.48");
	
title = "WELLCOME";
msg = "***********************************************************************************************************\n"
	+"For starting, please drag & drop the image on Image J panel or click \"OK\" to select it from directory manager.\n"
	+"***********************************************************************************************************\n"
	+" \n"
	+" \n"
	+"Valeh Rustamov\n"
	+"rustamov@doktoranden.hs-mannheim.de \n"
	+" \n"
	+"Institute of Molecular and Cell Biology,\n"
	+"Mannheim University of Applied Sciences, Mannheim, Germany\n"
	+" \n"
	+"Institute of Medical Technology,\n"
	+"Heidelberg University, Heidelberg, Germany\n"
	+"_____________________________________________________________\n"
	+" AG Prof. Rüdiger Rudolf & Prof. Mathias Hafner  \n"
	+" www.uni-heidelberg.de/izn/researchgroups/rudolf/	\n";

  	waitForUser(title, msg);
  	run("Set Measurements...", "area mean modal min integrated median limit redirect=None decimal=3");
  
/// select a image and format

  	if (nImages>=1) {sc=getBoolean("Is this a multichannel image?");
  	if (sc==1) {run("Split Channels");
	title="NOTE";
  	msg="Select a channel for segmentation and then click \"OK\". ";
    waitForUser(title, msg);
    run("Grays");
    run("Duplicate...", "title=Working_Duplicate"); getImageID();}
  	else if (sc==0) {run("Grays"); run("Duplicate...", "title=Working_Duplicate"); getImageID();}}
  	
  	else if (nImages==0) {ch=getBoolean("Please select a image");
  	if (ch==1) {open();sc=getBoolean("Is this a multichannel image?");
  	if (sc==1) {run("Split Channels");
	title="NOTE";
  	msg="Select a channel for segmentation and then click \"OK\". ";
    waitForUser(title, msg);
    run("Grays");
    run("Duplicate...", "title=Working_Duplicate"); getImageID();}
  	else if (sc==0) {run("Grays"); run("Duplicate...", "title=Working_Duplicate"); getImageID();}}
  	else if (ch==0) {showMessage("EXIT","NOTE: No image is open");
  	print("\\Clear"); 
  	print("No image is open");
  	exit;}}
  	
// image adjusting steps

rd=getNumber("Median Filter: For removing \"noise-pixels\" add a radius value: [recommended]", 1);
	run("Mean...", "Median="+rd);
	
	run("Brightness/Contrast...");
	
title = "1. IMAGE ADJUSTING";
msg = "Adjust the duplicate for brightness/contrast to distinguish the structure against the background, then click \"OK\".\n"
+"___________________________________________________________________________\n"
+"NOTE: After adjusting of the image don't click the \"Apply\" button on B&C Window!\n";
	waitForUser(title, msg);
	getImageID;
	name="Binary_Mask" + ".tiff";
	rename(name);
	
 	run("Apply LUT");
	run("Convert to Mask");
	run("Dilate");
	run("Watershed");
	
	setAutoThreshold("Default dark");
	setAutoThreshold("Default");

	roiManager("Deselect");
	
	ap=getNumber("Analyzing particles: For analyzing particles add a size of particles: [recommended ]", 50);
	run("Analyze Particles...", "size="+ap+" pixel display clear add");

	image1=getImageID;

title = "2. ANALYZE PARTICLES";
msg = "TAKE THE FOLLOWING STEPS: \n"
	+"				\n" 
	+"1. Check all ROIs, if neccessary mark ROIs with \"Wand (tracing) Tool\" and then press the  \"t\" key on your keyboard to add them in \"ROI Manager\". \n" 
	+"				\n" 
	+"2. For remove unspecific ROIs, first select the ROI and then press the \"Delete\" key on your keyboard.  \n" 
	+"				 \n" 
	+"3. At the end select a original RAW image for transfer all ROIs from \"Working_Duplicate\" on it, then click \"OK\".\n";
	waitForUser(title, msg);
	
	image2=getImageID;
	info=getTitle();
	run("Duplicate...", "title="+info+"+ROIs");
	
	image3=getImageID;
	roiManager("Show All without labels");
	
title = "3. LAST STEP";
msg = "Check of all ROIs on RAW image,then click \"OK\".";
	waitForUser(title, msg);
	roiManager("Measure");
	IJ.deleteRows(0, 100000);
	roiManager("Measure");
	roiManager("Show All with labels")
	run("Summarize");

// Show Results
nROIs = roiManager("count");
	print("\\Clear");
msg="Total number of ROIs, e.g Ki67/Casp3/Nuclei:   "+ nROIs;
	print(msg);
	
// Save all measurements
	run("Set Measurements...", "area mean modal min integrated median limit redirect=None decimal=3");
	run("Input/Output...", "jpeg=100 gif=-1 file=.xls copy_column copy_row save_column save_row");
NOTE1=getBoolean("Do you want to save measurements as .xls file?");
	if (NOTE1==1) { dir = getDirectory("Choose a Directory"); selectWindow("Results"); 
    saveAs("Results", dir+"Results.xls");}
	else if (NOTE1==0) {}
	
// Save all ROIs
NOTE2=getBoolean("Do you want to save all ROIs as .zip file?");
	if (NOTE2==1) {dir = getDirectory("Choose a Directory");
	roiManager("Save", dir+"RoiSet.zip");}
	else if (NOTE2==0) {}
	
// Save all images 
NOTE3=getBoolean("Do you want to save all images as .tiff file?");
	if (NOTE3==1) {dir = getDirectory("Choose a Directory"); 
	
///////
	setBatchMode(true);
///////

	selectImage(image1); 
	title1 = getTitle; 
	print(title1);
	getImageID;
	saveAs("tiff", dir + title1);
        
	selectImage(image2); 
	title2 = getTitle; 
	print(title2);
	getImageID;
	saveAs("tiff", dir + title2);
        
	selectImage(image3); 
	title3 = getTitle; 
	print(title3);
	getImageID;
	saveAs("tiff", dir + title3);}
        
	else if (NOTE3==0) {}

///////
	setBatchMode(false);	
	setBatchMode("exit and display");
///////

NOTE4=getBoolean("Do you want to close all segmented images?");
	if (NOTE4==1) { 
///////
	setBatchMode(true);
///////

	selectImage(image1); 
	title1 = getTitle; 
	print(title1);
	getImageID;	
  	close();
  	
	selectImage(image2); 
	title1 = getTitle; 
	print(title1);
	getImageID;	
	close();
	
	selectImage(image3); 
	title1 = getTitle; 
	print(title1);
	getImageID;	
	close();

	showMessage("FINISH", "Image was successfully segmented!");
	
	NOTE41=getBoolean("Do you want segmenting next channel?");
	if (NOTE41==1) { list = getList("window.titles"); 
     for (i=0; i<list.length; i++){ 
     Closeallwin = list[i]; 
     selectWindow(Closeallwin); 
     run("Close");} }
	else if (NOTE41==0) {showMessage("FINISH", "Image was successfully segmented!");}
	}
	
	else if (NOTE4==0) {showMessage("FINISH", "Image was successfully segmented!");}
///////
	setBatchMode(false);	
///////
}
